
import java.sql.*;
import java.util.*;
/*
 * Ket noi CSDL va tao DB
 */

public class AccountDB {
    /* Phuong thuc nay lay du lieu va tao Account */
    public static Account getAccount(int accNo){
        Account acc=new Account();
        String sqlStatement ="select * from Account where AccountNo=" + accNo;
        Connection dbConn = DBConnection.getConnection();
        try{
            PreparedStatement ps = dbConn.prepareStatement(sqlStatement);
            ResultSet rs =ps.executeQuery();
            if(rs.next()){
                acc.setAccountNo(accNo);
                acc.setCustomerName(rs.getString("CustomerName"));
                acc.setPassword(rs.getString("Passwd").trim());
                acc.setAmount(rs.getDouble("Amount"));
            }else{
                return null;
            }
        }catch(SQLException e){
            return null;
        }
        return acc;
    }
    // Lay danh sach account
    public ArrayList<Account> getAccounts()
    {
        String sql="Select * from Account";
        ArrayList<Account> accounts = new ArrayList<>();
        Connection dbConn = DBConnection.getConnection();
        try
        {
            PreparedStatement ps= dbConn.prepareStatement(sql);
            ResultSet rs=ps.executeQuery();
            
            while(rs.next()){
                Account acc= new Account();
                acc.setAccountNo(rs.getInt("AccountNo"));
                acc.setCustomerName(rs.getString("CustomerName"));
                acc.setPassword(rs.getString("Passwd").trim());
                acc.setAmount(rs.getDouble("Amount"));
                accounts.add(acc);
            }
            return accounts;
        }
        catch(SQLException e){
            return null;
        }
    }
    //Xoa mot Account tu CSDL
    public boolean deleteAccount(Account acc){
        String sql="Delete from Account Where AccountNo=?";
        Connection dbConn = DBConnection.getConnection();
        try
        {
            PreparedStatement ps= dbConn.prepareStatement(sql);
            ps.setInt(1, acc.getAccountNo());
            ps.executeUpdate();
            return true;
        }
        catch(SQLException e){
            return false;
        }
    }
    // Cap nhat bang ghi tren CSDL
    public boolean updateAccount(Account acc){
        String sql="Update Account SET " + "CustomerName = ?, " +
                      "Passwd=?, " + "Amount =? " +
                       "WHERE AccountNo = ?";
        Connection dbConn = DBConnection.getConnection();
        try
        {
            PreparedStatement ps= dbConn.prepareStatement(sql);
            ps.setString(1, acc.getCustomerName().trim());
            ps.setString(2, acc.getPassword().trim());
            ps.setDouble(3, acc.getAmount());
            ps.executeUpdate();
            return true;
        }
        catch(SQLException e){
            return false;
        }
    }
}
